1d7b5c7d296115f565f6fe379d54a56b427ce468
[automated-distro-installer] / fai / config / files / root / fai-check / VOL_BULLSEYE_BOOTSTRAP
1 #!/bin/bash
2
3 set -eE -o pipefail
4 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
5
6
7
8 usage() {
9 cat <<EOF
10 Usage: ${0##*/} [OPTION] [HOST]
11 If grub var set, act like pxe rom and pxe-kexec to faiserver
12
13 -f|--force do kexec if we can reach faiserver
14 -h|--help Print help and exit.
15
16 Note: Uses GNU getopt options parsing style
17 EOF
18 exit $1
19 }
20
21
22
23 # Keep it short so we don't delay too much wnen we don't have networking.
24 # In practice, on my home network, on an x200, it took 15 seconds, so
25 # give it an extra 10 seconds, which seems fairly short as I write this.
26 NETWORK_TIMOUT_SECS=25
27 did_fai_check=false
28
29 m() { printf "%s\n" "$*"; "$@"; }
30
31 try-kexec() {
32 deadline=$(( `date +%s` + NETWORK_TIMOUT_SECS ))
33 while ! timeout -s 9 3 nc -zu $faiserver 69; do
34 if (( `date +%s` > deadline )); then
35 echo "fai-check: hit $NETWORK_TIMOUT_SECS s tftp server timeout"
36 return 0
37 fi
38 sleep 1
39 done
40 m pxe-kexec -n --ignore-whitelist -l fai-generated $faiserver ||:
41 }
42
43 force=false
44 case $1 in
45 -h|--help)
46 usage
47 ;;
48 -f|--force)
49 force=true
50 shift
51 ;;
52 esac
53
54 faiserver=${1:-faiserver}
55
56
57 if $force; then
58 try-kexec
59 exit
60 fi
61
62 first=true
63 for dev in $(btrfs fi show / | sed -rn 's#^\s*devid\s.*\s([^0-9 ]+)\S+$#\1#p' \
64 |sort); do
65
66 found=false
67 # Decide which is my grub_ext partition. see partition.DEFAULT file
68 # for details. currently it is 4
69 for (( i=4; i<=7; i++ )); do
70 if [[ $(blockdev --getsize64 ${dev}$i) == 8388608 ]]; then
71 grub_extn=${dev}$i
72 break
73 fi
74 done
75 if ! $found; then
76 echo "$0: error: failed to find grub_ext partition."
77 exit 1
78 fi
79 mount $grub_extn /mnt
80 if $first; then
81 if [[ -e /mnt/grubenv ]]; then
82 set -x
83 source <(grub-editenv /mnt/grubenv list)
84 set +x
85 fi
86 first=false
87 # we could just as well check if last_boot != /debianbullseye_bootstrap
88 # the intent with this one is just a little clearer.
89 if [[ $did_fai_check == true ]]; then
90 grub-editenv /mnt/grubenv set did_fai_check=os_true
91 # our service does not wait for network-online.target,
92 # because it will wait for too long when we don't have a network
93 # connection. So, we wait for 10 seconds.
94 # ref: https://www.freedesktop.org/wiki/Software/systemd/NetworkTarget/
95 try-kexec ||:
96 fi
97 else
98 # we make sure there is only 1 grubenv,
99 # so grub can just find the first one, in whatever order
100 # if looks at them, which may not be the same as us.
101 # If the disk dies, we just lose the default boot option,
102 # we will have to do manual steps to replace it anyways.
103 rm -f /mnt/gruvenv
104 fi
105 umount /mnt
106 done
107
108 # the check for last_boot is not needed afaik, just sanity check.
109 if [[ $did_fai_check == true && $last_boot != /debianbullseye_bootstrap ]]; then
110 # no need to reboot if we actually want to boot into this os.
111 reboot
112 fi